---
title: Cross-Origin Resource Policy (CORP)
slug: Web/HTTP/Cross-Origin_Resource_Policy_(CORP)
tags:
  - HTTP
  - Reference
  - Security
---
<div>{{HTTPSidebar}}</div>

<p class="summary"><span class="seoSummary"><strong>Cross-Origin Resource Policy</strong> is a policy set by the <a href="/en-US/docs/Web/HTTP/Headers/Cross-Origin-Resource-Policy"><code>Cross-Origin-Resource-Policy</code> HTTP header</a> that lets web sites and applications opt in to protection against certain requests from other origins (such as those issued with elements like <code>&lt;script&gt;</code> and <code>&lt;img&gt;</code>), to mitigate speculative side-channel attacks, like <a href="https://en.wikipedia.org/wiki/Spectre_(security_vulnerability)">Spectre</a>, as well as Cross-Site Script Inclusion attacks.</span></p>

<p class="summary">CORP is an additional layer of protection beyond the default {{Glossary("same-origin policy")}}. Cross-Origin Resource Policy complements <a href="https://fetch.spec.whatwg.org/#corb">Cross-Origin Read Blocking</a> (CORB), which is a mechanism to prevent some cross-origin reads by default.</p>

<div class="notecard note">
<p>The policy is only effective for <a href="https://fetch.spec.whatwg.org/#concept-request-mode"><samp>no-cors</samp></a> requests, which are issued by default for CORS-safelisted methods/headers.</p>
</div>

<p>As this policy is expressed via a <em><a href="/en-US/docs/Glossary/Response_header">response header</a></em>, the actual request is not prevented—rather, the browser prevents the <em>result</em> from being leaked by stripping the response body.</p>

<h2 id="History">History</h2>

<p>The concept was originally proposed in 2012 (as <samp>From-Origin</samp>), but <a href="https://github.com/whatwg/fetch/issues/687">resurrected</a> in Q2 of 2018 and implemented in Safari and Chromium.</p>

<p>In early 2018, two side-channel hardware vulnerabilities known as <em>Meltdown</em> and <em>Spectre</em> were disclosed. These vulnerabilities allowed sensitive data disclosure due to a race condition which arose as part of speculative execution functionality, designed to improve performance.</p>

<p>In response, Chromium shipped <a href="https://fetch.spec.whatwg.org/#corb">Cross-Origin Read Blocking</a>, which automatically protects certain resources (of <samp>Content-Type</samp> HTML, JSON and XML) against cross-origin reads. If the application does not serve a <a href="/en-US/docs/Web/HTTP/Headers/X-Content-Type-Options"><code>no-sniff</code> directive</a>, Chromium will attempt to guess the <samp>Content-Type</samp> and apply the protection anyway.</p>

<p>Cross-Origin Resource Policy is an opt-in response header which can protect <em>any</em> resource; there is no need for browsers to sniff MIME types.</p>

<h2 id="Usage">Usage</h2>

<div class="note">
<p><strong>Note:</strong> Due to a <a href="https://bugs.chromium.org/p/chromium/issues/detail?id=1074261">bug in Chrome</a>, setting Cross-Origin-Resource-Policy can break PDF rendering, preventing visitors from being able to read past the first page of some PDFs. Exercise caution using this header in a production environment.</p>
</div>

<p>Web applications set a Cross-Origin Resource Policy via the {{HTTPHeader("Cross-Origin-Resource-Policy")}} HTTP response header, which accepts one of three values:</p>

<dl>
 <dt>same-site</dt>
 <dd>
 <p>Only requests from the same <em>{{Glossary("Site")}}</em> can read the resource.</p>

 <div class="notecard warning">
 <p><strong>Warning:</strong> This is less secure than an {{Glossary("origin")}}. The <a href="https://html.spec.whatwg.org/multipage/origin.html#same-site">algorithm for checking if two origins are same site</a> is defined in the HTML standard and involves checking the <em>registrable domain</em>.</p>
 </div>
 </dd>
 <dt>same-origin</dt>
 <dd>Only requests from the same <em>{{Glossary("origin")}}</em> (i.e. scheme + host + port) can read the resource.</dd>
 <dt>cross-origin</dt>
 <dd>Requests from any <em>{{Glossary("origin")}}</em> (both same-site and cross-site) can read the resource.</dd>
</dl>

<pre class="notranslate">Cross-Origin-Resource-Policy: same-site | same-origin | cross-origin</pre>

<p>During a cross-origin resource policy check, if the header is set, the browser will deny <code>no-cors</code> requests issued from a different origin/site.</p>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("http.headers.Cross-Origin-Resource-Policy")}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Fetch", '#cross-origin-resource-policy-header')}}</td>
   <td>{{Spec2("Fetch", '#cross-origin-resource-policy-header')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{HTTPHeader("Cross-Origin-Resource-Policy")}} HTTP Header</li>
 <li><a href="https://bugzilla.mozilla.org/show_bug.cgi?id=1459573">Bugzilla bug 1459573</a></li>
</ul>
